import urllib2
import re
import time

class HoerzuEPG:
	
	_epg_data = None
	
	def __init__(self):
		try:
			self._epg_data = self._fetch_data()
		except:
			pass
		
	def get_epg_channel(self, channel_name):
		retval = None
		try:
			for channel in self._epg_data:
				if channel_name.encode("utf-8") == channel["name"]:
					retval = channel["info"]
		except:
			pass
		return retval
	
	def _fetch_data(self):
		channel_list = []
		current_time = time.strftime("%H:%M")
		stime = (int(time.strftime("%H")) * 60) + (int(time.strftime("%M")))
		url = "http://www.hoerzu.de/tv-programm/heute/%s/" % (current_time)

		reply = urllib2.urlopen(url)
		html = reply.read()

		hoerzu_de = re.compile('(?P<all><div class="channel">(?P<channel>.*?)</div>.*?<b class="title">(?P<show>.*?)</b>.*?<span class="starttime">(?P<start>.*?)</span>.*?<span class="starttime">(?P<end>.*?)</span>)', re.DOTALL)
		category = re.compile('<span class=\"year-country\">(.*?)</span>', re.DOTALL)

		for m in hoerzu_de.finditer(html):
			cat = category.search(m.group(0))
			if cat is not None:
				cat = cat.group(1)
				cat = re.sub(r'\s\b[A-Z]{1,3}.*|\s.\b[0-9]{4}.*', '', cat).strip()
			else:
				cat = ""
				
			hours 	= int(m.group("end").split(":")[0])
			minutes = int(m.group("end").split(":")[1])
			etime = hours*60 + minutes
			
			hours 	= int(m.group("start").split(":")[0])
			minutes = int(m.group("start").split(":")[1])
			stime_epg = hours*60 + minutes
			
			if etime > stime:
				remaining = etime - stime
			else:
				remaining = (etime + 24*60) - stime
				
			if etime == stime_epg:
				remaining = "??"

			if cat != "":
				the_string = "{0} (noch {1}' | {2})".format(m.group("show"), str(remaining), cat)
			else:
				the_string = "{0} (noch {1}')".format(m.group("show"), str(remaining))
			
			the_string = the_string.decode("utf-8")
			
			channel_list.append({	"name":m.group("channel"),
									"info":the_string})

		return channel_list